<?php
use LabBase\Model\Brand;
use LabBase\Model\BrandPost;
use LabBase\Model\Category;
use LabBase\Model\User;

$brandBannerChangeURL = $this->url('root/brandSettings', ['action' => 'uploadBanner', 'param' => $this->thisBrand->url]);

$thisBrandLogoURL = \LabBase\Model\ImageSaver::GetImageS3LinkFromName('brand-avatar-'.$this->thisBrand->id);
$thisBrandURL = $this->url('root/brandFeed', ['brandUrl' => $this->thisBrand->url]);

/** @var $user User */
$user = $this->sessionInfo()->getLoggedInUser();
?>

<script>
    var g_thisBrand = {
        id: <?= $this->thisBrand->id; ?>,
        name: '<?= addslashes($this->thisBrand->name); ?>',
        category: '<?= addslashes($this->categoryUrl); ?>',
        url: '<?= addslashes($this->thisBrand->url); ?>',
        loveCount: <?= $this->thisBrand->loveCount; ?>,
        lovedByUser: <?= $this->brandLovedByUser ? 'true' : 'false' ?>
    };
    <?php if($user) { ?>

    var g_loggedInUser = {
        id: <?= $user->id; ?>,
        name: '<?= addslashes($user->fullName) ?>',
        isAdmin: <?= $user->isAdmin() ? 'true' : 'false'  ?>,
        canEditBrand: <?= $this->userCanEditBrand ? 'true' : 'false' ?>
    };
    <?php }else{ ?>
    var g_loggedInUser = false;
    <?php } ?>
</script>

<?php


$brandName = null;
if($this->BrandName) {
    $brandName = $this->BrandName;
    $brandUrl = $this->BrandUrl;
    $brandDescription = $this->BrandDescription;
}else{
    if ($user && $user->lastVisitedBrandId !== null) {
        /** @var Brand $brand */
        $brand = $this->sessionInfo()->getBrandById($user->lastVisitedBrandId);
        if ($brand) {
            $brandName = $brand->name;
            $brandDescription = $brand->description;
            $brandUrl = $brand->url;
        }
    }
    else{
        $brandName = $this->thisBrand->name;
        $brandDescription = $this->thisBrand->description;
        $brandUrl = $this->thisBrand->url;
    }
}
$thisBrand = $this->thisBrand;
?>


<iframe id="editorImageSubmitterIframe" name="editorImageSubmitterIframe" style="display: none;" onload="if(this.contentWindow.location.href != 'about:blank' && window.imageUploadSubmitted) {window.imageUploadSubmitted(this)}"> </iframe>
<form onsubmit="window.imageUploadStarted()" enctype="multipart/form-data" method="post" target="editorImageSubmitterIframe" action="<?= $this->url('root/brandServiceAddImage', ['brandUrl' => $brandUrl]); ?>">
    <input type="file" name="image" style="display: none" id="editorImageSubmitter" onchange="$(this).parent().submit()" />
</form>
<script>
    window.imageUploadStarted = function() {
        window.postImageUploadFinished = window.loadingIndicator($('body')); 
    };
    window.imageUploadEnded = function() {
        if (window.postImageUploadFinished) {
            window.postImageUploadFinished();
        }
    };

    window.imageSubmittedCallback = false;
    window.imageUploadSubmitted = function(el) {
        window.imageUploadEnded();

        if(window.imageSubmittedCallback === false) return;
        var iframeContents = $(el)[0].contentDocument.body.innerHTML;

        var re = /\{[\-a-zA-Z"'0-9:\w|.,/\\]+\}/.exec(iframeContents);
        if(re == null) {
            labAlert("An error has occured while uploading the photo.");
            window.imageSubmittedCallback(false);
            window.imageSubmittedCallback = false;
            return;
        }
        var response = re[0];
        response = JSON.parse(response);
        console.log("Successfully uploaded image:", response);
        window.imageSubmittedCallback(response.imageLink);
        window.imageSubmittedCallback = false;
    };
</script>


<!-- Header -->
    <?php echo $this->render('brand-header.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); ?>
<!--END-->

<div class="body-content">
   
    <div class="wrapper">
        
        <!-- Intro -->
        <?php /*echo $this->render('brand-body-top.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); */?>
        <!--END-->

        <!-- Sidebar Layout -->
        <div class="sidebar-layout">
            <?php echo $this->render('band-menu.phtml', array('page' => 'service', 'brandUrl' => $this->thisBrand->url)); ?>
            
            <!-- Main Content -->
            <div class="col-md-12 col-sm-12 col-xs-12">
                <div class="row service-section">
                    
                    <div class="panel panel-default service-brand-container">
                        <div class="panel-body">
                            <?php if($this->userCanEditBrand){ ?>
                                <div class="edit_action pull-right">
                                    <div class="dropdown">
                                        <a href="#" class="dropdown-toggle" aria-expanded="false" data-toggle="dropdown">
                                            <i class="fa fa-pencil" aria-hidden="true"></i>
                                        </a>
                                        <ul class="dropdown-menu dropdown-menu-right">
                                            <li>
                                                <?php
                                                    $titleText = "Show title field";
                                                    $titleFlag = 1;
                                                    if($thisBrand->public_name)
                                                    {
                                                        $titleText = "Hide title field";
                                                        $titleFlag = 0;
                                                    }
                                                ?>                                            
                                                <a style="display:<?php echo ($thisBrand->public_name) ? "none" : ''; ?>" href="javascript: void(0);" class="showServiceTitle" data-flag="1" onclick="makePublicOrNot(this, 'title');">
                                                    Show title field
                                                </a>
                                                
                                                <a style="display:<?php echo (!$thisBrand->public_name) ? "none" : ''; ?>" href="javascript: void(0);" class="hideServiceTitle" data-flag="0" onclick="makePublicOrNot(this, 'title');">
                                                    Hide title field
                                                </a>
                                                
                                            </li>
                                            <li>
                                                <?php
                                                    $titleDesc = "Show description field";
                                                    $descFlag = 1;
                                                    if($thisBrand->public_description)
                                                    {
                                                        $titleDesc = "Hide description field";
                                                        $descFlag = 0;
                                                    }
                                                ?>                                            
                                                <a style="display:<?php echo ($thisBrand->public_description) ? "none" : ''; ?>" class="showServiceDescription" href="javascript: void(0);" data-flag="1" onclick="makePublicOrNot(this, 'description');">
                                                    Show description field
                                                </a>
                                                <a style="display:<?php echo (!$thisBrand->public_description) ? "none" : ''; ?>" class="hideServiceDescription" href="javascript: void(0);" data-flag="0" onclick="makePublicOrNot(this, 'description');">
                                                    Hide description field
                                                </a>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                            <?php } ?>
                            
                            <div class="col-md-12">
                                <div class="col-md-8 col-md-offset-2">
                                    
                                        <div class="form-group" style="<?php echo (!$thisBrand->public_name) ? 'display:none;' : ''; ?>">
                                            <?php if($this->userCanEditBrand){ ?>
                                                <input type="text" class="form-control service-head-title" id="serviceTitle" placeholder="Title e.g. Our Services, for you" value="<?php echo $brandName; ?>" onblur="javascript: changeTitleOrDescription(this, 'title');">
                                                <a href="javascript:void(0);" data-flag="0" onclick="javascript: makePublicOrNot(this, 'title');" class="hide_block title-hide"><i class="fa fa-times" aria-hidden="true"></i></a>
                                            <?php }else{ ?>
                                                <div class="service-head-title-text"><?php echo $brandName; ?></div>
                                            <?php } ?>
                                        </div>
                                    
                                    
                                    <div class="form-group" style="<?php echo (!$thisBrand->public_description) ? 'display:none;' : ''; ?>">
                                        <?php if($this->userCanEditBrand){ ?>
                                            <textarea class="textarea-scrollbar scrollbar-outer service-head-description" onblur="javascript: changeTitleOrDescription(this, 'description');"><?php echo $brandDescription; ?></textarea>
                                            <a href="javascript:void(0);" data-flag="0" onclick="javascript: makePublicOrNot(this, 'description');" class="hide_block description-hide"><i class="fa fa-times" aria-hidden="true"></i></a>
                                        <?php }else{ ?>
                                                <div class="service-head-description-text"><?php echo $brandDescription; ?></div>
                                        <?php } ?>
                                    </div>
                                    
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    
                    <div class="panel panel-default service_container">
                        <div class="panel-body">
                            
                            <div class="col-md-12 nopadding">
                                <?php if($this->userCanEditBrand){ ?>
                                    <div class="col-md-4 col-sm-4 col-xsm-6">
                                    <div class="service_content add_service_content">
                                        <a href="javascript: void(0);" id="add_service_box">
                                            <div class="service_add_icon img-circle">
                                                <i class="icon-plus"></i>
                                            </div>
                                            <div class="service_add_text">
                                                Add Services
                                            </div>
                                        </a>
                                    </div>
                                    </div>
                                    
                                    <div class="col-md-4 col-sm-4 col-xsm-6 service_add_form" style="display:none;">
                                        <div class="service_content">
                                            <div class="service_image_box">
                                                <div class="service_add_photo_icon img-circle" onclick="uploadImage('service');">
                                                    <span>
                                                        <i class="fa fa-picture-o step1" aria-hidden="true"></i>
                                                        <i class="fa fa-plus-circle step2" aria-hidden="true"></i>
                                                    </span>
                                                </div>
                                                <div style="display:none;" data-type="service" class="upload-image-list-service editable small-image-section"></div>
                                            </div>
                                            <div class="service_add">
                                                <div class="form-group">
                                                    <input type="text" class="form-control service_add_title" placeholder="Service title" />
                                                </div>
                                                <div class="form-group">
                                                    <textarea class="textarea-scrollbar scrollbar-outer service_add_description form-control" placeholder="A short service description" rows="3"></textarea>
                                                </div>
                                                <div class="form-group">
                                                    <button class="btn btn-info pull-right" onclick="javascript: addServiceData();">Submit</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                <?php } ?>
                                
                                <?php if(!empty($this->serviceList)){ ?>
                                    <?php foreach($this->serviceList as $singleService){ ?>
                                        <div id="feed_service_<?php echo $singleService->id; ?>" class="col-md-4 col-sm-4 col-xsm-6">
                                            <div id="display_service_<?php echo $singleService->id; ?>">
                                                <div class="service_content">
                                                    <?php if($this->userCanEditBrand){ ?>
                                                        <div class="dropdown service-actions">
                                                        <a href="#" class="dropdown-toggle" aria-expanded="false" data-toggle="dropdown">
                                                            <i class="fa fa-pencil" aria-hidden="true"></i>
                                                        </a>
                                                        <ul class="dropdown-menu dropdown-menu-right">
                                                            <li>
                                                                <a href="javascript: void(0);" data-id="<?php echo $singleService->id; ?>" onclick="editServicePopup(this);">
                                                                    Edit
                                                                </a>
                                                            </li>
                                                            <li>
                                                                <a href="<?php echo $this->url("root/brandDeleteService", ["serviceId" => $singleService->id]); ?>" onclick="javascript: deleteService($(this)); return false;" data-id="<?php echo $singleService->id; ?>">
                                                                    Delete
                                                                </a>
                                                            </li>
                                                        </ul>
                                                    </div>
                                                    <?php } ?>
                                                    <div class="service_image_box">
                                                        <?php 
                                                            if($singleService->serviceImageData)
                                                            {
                                                                $serviceImage = json_decode($singleService->serviceImageData);
                                                            }
                                                        ?>
                                                        <?php if(empty($serviceImage)){ ?>
                                                            <div class="service_no_photo_icon img-circle">
                                                                No Photo
                                                            </div>
                                                        <?php }else{ ?>
                                                            <div class="small-image-section">
                                                                <div class="img-row row-of-one">
                                                                    <div class="img-container col-one">
                                                                        <img src="<?php echo $serviceImage[0]->url; ?>">
                                                                        <div class="img-panel active"></div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        <?php } ?>
                                                    </div>
                                                    <div class="service_meta_box">
                                                        <div class="service_meta_title">
                                                            <?php echo $singleService->serviceTitle; ?>
                                                        </div>
                                                        <div class="service_meta_description">
                                                            <?php if(isset($singleService->serviceContentTrunc) && $singleService->serviceContentTrunc != ""){ ?>
                                                                <div id="trunc_description_<?php echo $singleService->id; ?>">
                                                                    <?php echo $singleService->serviceContentTrunc; ?>
                                                                    <a href="javascript:void(0);" class="read_action" onclick="javascript: showHideContent('show', '<?php echo $singleService->id; ?>');">more</a>
                                                                </div>
                                                                <div id="full_description_<?php echo $singleService->id; ?>" style="display:none;">
                                                                    <?php echo $singleService->serviceContent; ?>
                                                                    <a href="javascript:void(0);" class="read_action" onclick="javascript: showHideContent('hide', '<?php echo $singleService->id; ?>');">less</a>
                                                                </div>
                                                            <?php }else{ ?>
                                                                <div id="full_description_<?php echo $singleService->id; ?>">
                                                                    <?php echo $singleService->serviceContent; ?>
                                                                </div>
                                                            <?php } ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                           
                                        </div>
                                    <?php } ?>
                                <?php } ?>
                                
                            </div>
                            
                        </div>
                    </div>
                    
                </div>
            </div>
            
        </div>
    </div>
    
</div>

<!-- Footer -->
    <?php echo $this->render('brand-footer.phtml', array('user' => $user, 'thisBrand' => $this->thisBrand, 'draftspostCnt' => $this->draftspostCnt, 'brandName' => $brandName, 'thisBrandLogoURL' => $thisBrandLogoURL)); ?>
<!--END-->

<input type="hidden" value="<?php echo $this->postType; ?>" name="hdnPostType" id="hdnPostType" />

<script src="//cdnjs.cloudflare.com/ajax/libs/Sortable/1.4.2/Sortable.min.js"></script>

<script>

    function calculateDates() {
        var postType = document.getElementById('hdnPostType').value;
        var elements = document.querySelectorAll("[data-date]");
        for(var el in elements) {
            if(!elements.hasOwnProperty(el)) continue;
            el = elements[el];
            if(postType == 'drafts')
            {
                el.innerHTML = 'saved '+formatAgoTime(el.dataset.date);
            }
            else
            {
                el.innerHTML = formatAgoTime(el.dataset.date);
            }
        }
    }
    window.setInterval(calculateDates, 1000 * 29);
    window.onGloabalJS.push(calculateDates);

    <? if($user) { ?>
    window.onGloabalJS.push(function() {
        window.getNotifications('feed-template');
    });
    <? } ?>

    function updateLoveUsButton() {
        if(g_thisBrand.lovedByUser) {
            $('#loveUsButton .text').text('Loved!');
        }else{
            $('#loveUsButton .text').text('Love Us');
        }
    }

    window.loveUsClicked = function(el) {
        var loveBool = !g_thisBrand.lovedByUser;
        window.ajaxSubmitCheck("<?= $this->url("root/interactionController", ["action" => "loveBrand", "param" => $this->thisBrand->id, "param2" => "BOOL"]) ?>".replace(/BOOL/, loveBool), {}, function (data) {
            g_thisBrand.lovedByUser = data.newValue;
            updateLoveUsButton();
        }, "Could not love the brand. %s");
    };
    onGloabalJS.push(updateLoveUsButton);

    function changeBrandAvatar() {
        <?php if($this->userCanEditBrand) { ?>
        labImage('Change brand avatar image', function(imageData) {
            if(imageData) {
                $('.loading-container').show();
                window.ajaxSubmitCheck('<?= $this->url('root/brandSettings', ['action'=>'uploadAvatar', 'param' => $this->thisBrand->url]) ?>', {
                    imageString: imageData.data.split('base64,', 2)[1]
                }, function() {
                    document.location.reload();
                }, "The brand avatar couldn't be changed. %s");
            }
        }, 400, 400);
        <?php }else{ ?>
        return false;
        <?php } ?>
    }

    var UploadedImagesListSelService = '.upload-image-list-service';
    
    window.onGloabalJS.push(function() {
        window.uploadImageSetStorageService = window.persistentVariableService("uploadImageSetService", new window.ImageSet([], UploadedImagesListSelService));
        if(window.uploadImageSetStorageService.get().type !== 'ImageSet') {
            window.uploadImageSetStorageService.set(new window.ImageSet([], UploadedImagesListSelService));
        }
        console.log("uploadImageSetService = ", window.uploadImageSetStorageService, window.uploadImageSetStorageService.get());
    });
    
    function removeImageClicked(el, type) {
        var $container = $(el).closest('.img-container');
        var $img = $('img', $container);
        var confirm = labConfirm("Are you sure you want to delete this image?", "Confirm delete",
        function(response) {
            if(response) {
                removeImage($img.attr('src'), type);
            }
        }, "Delete", "Cancel");
    }

    function removeImage(img, type) {
        switch(type)
        {
            case 'service' : 
                    var imageSet = window.uploadImageSetStorageService.get();
                    imageSet.removeImages([img]);
                    window.uploadImageSetStorageService.set(imageSet);
                    
                    $('.upload-image-list-service').hide();
                    $('.service_add_photo_icon').show();
                    
                break;            
        }
    }
    
    function uploadImageToEditorService(img) {
        console.log(img);
        console.log('Upload Service image Service');
        var imageSetService = uploadImageSetStorageService.get();
        imageSetService.addImages([img]);
        window.uploadImageSetStorageService.set(imageSetService);
    }
    
    function uploadImage(type) {
        var handelClass = '.upload-image-list-'+type;
        window.imageSubmittedCallback = uploadImageToEditorService;
        
        $("#editorImageSubmitter").click();
    }
    
    
    /*************************************************************************************/
    
    function changeTitleOrDescription(obj, type)
    {
        var content = $(obj).val().trim();
        
        if(content == "" && content.length < 1)
        {
            labAlert("Please fill in the "+type+" before submitting.");
            return;
        }
        
        ajaxSubmit('<?= $this->url('root/brandManageSettings', ['brandUrl' => $this->thisBrand->url]) ?>', {
            'content': content,
            'type': type,
            }, function(data) {
                if(!data || !data.status || data.status != 'ok') {
                    console.log("error:", data);
                    var error = "Please try again later or contact the support team.";
                    if(data && data.status) error = data.status;
                    labAlert("An error has occured. " + error);
                }else{
                    console.log(type+" submitted", data);
                    var updatedHtml = '<div class="updated update-container">'+type+' updated successfully.</div>';
                    $(obj).parent().append(updatedHtml);
                    setTimeout(function() {
                        if($('.update-container').length > 0)
                        {
                            $('.update-container').remove();
                        }
                   }, 2000);
                }
        });
    }
    
    function makePublicOrNot(obj, type)
    {
        var plublicType = 'public_'+type;
        var flag = $(obj).data('flag');
        
        var ele = $('.service-head-'+type);
        ajaxSubmit('<?= $this->url('root/brandManageSettings', ['brandUrl' => $this->thisBrand->url]) ?>', {
            'content': flag,
            'type': plublicType,
            }, function(data) {
                if(!data || !data.status || data.status != 'ok') {
                    console.log("error:", data);
                    var error = "Please try again later or contact the support team.";
                    if(data && data.status) error = data.status;
                    labAlert("An error has occured. " + error);
                }else{
                    if(flag == 0)
                    {
                        $(ele).parent().slideUp('slow');
                        switch(type)
                        {
                            case 'title' :
                                    $('.showServiceTitle').show();
                                    $('.hideServiceTitle').hide();
                                break;
                            case 'description' :
                                    $('.showServiceDescription').show();
                                    $('.hideServiceDescription').hide();
                                break;
                        }
                    }
                    else
                    {
                        $(ele).parent().slideDown('slow');
                        switch(type)
                        {
                            case 'title' :
                                    $('.hideServiceTitle').show();
                                    $('.showServiceTitle').hide();
                                break;
                            case 'description' :
                                    $('.hideServiceDescription').show();
                                    $('.showServiceDescription').hide();
                                break;
                        }
                    }
                }
        });
    }
    
    function showHideContent(type, id)
    {
        if(type == 'show')
        {
            $('#trunc_description_'+id).hide();
            $('#full_description_'+id).slideDown('slow');
        }
        else
        {
            $('#full_description_'+id).hide();
            $('#trunc_description_'+id).slideDown('slow');
        }
    }
    
    function deleteService($el)
    {
        labConfirm("Do you really want to delete this service?\nThis cannot be undone!", "Are you sure?", function(response) {
            if(response) {
                $el.blur();
                window.loadingIndicator($('body'));
                
                ajaxSubmit($el.attr('href'), {}, function (data) {
                if (!data.status || data.status != "ok") {
                    console.log("openAjaxLink error: ", data);
                    alert(data.status ? data.status : "An error has occurred, please try again.");
                } else {
                    $('#feed_service_'+$el.data('id')).hide('slow', function(){ $(this).remove();  });
                    $('.loading-indicator-background').remove();
                }
            });
            return false;
            }
        }, "Delete", "Cancel");
    }
    
    function editServicePopup(obj)
    {
        var serviceId = $(obj).data('id');
        
        window.loadingIndicator($('body')); 
        $('#serviceEditPopup').remove();
        ajaxSubmit('/$brandServicePopup/' + serviceId, {'serviceId' : serviceId}, function(data) {
                $('body').append(data);
                var img = $('.service_add #hdnserviceImage').val();
                
                if(img != "")
                {
                    removeImage(img, 'service');
                    uploadImageToEditorService(img);
                }
                $('.service_add_description').scrollbar();
                $('#serviceEditPopup').modal('show');
                $('.loading-indicator-background').remove();
        });
        
    }
    /*************************************************************************************/
    
    console.log("REG ONLOAD");
    window.onload = function() {
        console.log("FIRE ONLOAD");
       
       $(document).on('mouseover', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
        
        $(document).on('click', '.small-image-section .img-container', function(e) {
            e.preventDefault();
            var $this = $(this);
            var $panel = $('.img-panel', $this);
            if($panel.closest('.small-image-section').hasClass('editable')) {
                var type = $panel.closest('.small-image-section').data('type');
                $panel.toggleClass('active');
                if($panel.hasClass('active')) {
                    $('.img-panel', $this.parent().parent()).removeClass('active');
                    $panel.addClass('active');
                }
                if ($panel.hasClass('new')) {
                    $panel.removeClass('new');
                    $panel.html('<div class="buttons"><button type="button" onclick="removeImageClicked(this, \''+type+'\');" class="icon-close"></button></div>');
                }
            }
        });
       
       
       $('#add_service_box').click(function(){
           if($('.service_add_form').is(":hidden"))
           {
               $('.service_add_form').show('slow');
           }
           else
           {
               $('.service_add_form').hide('slow');
           }
       });
       
       if($('.service_container .upload-image-list-service div.img-row').length > 0)
        {
            $('.service_container .upload-image-list-service').show();
            $('.service_container .service_add_photo_icon').hide();
        }
       
        var $textareas = $('textarea.autoresize');

        // Comments
        window.autosizeTextarea($('.comment-form textarea.comment-content'), 60, 300);
        window.autosizeTextarea($textareas, 80, 1000); // todo: fix
    }

</script>


